#include <HardwareSerial.h>

HardwareSerial mySerial(1);

int btn1ESP = D0;
int btn2Ar = D1;
bool prevBtnState = false;
bool prevArduinoBtn = false;

void setup() {
  Serial.begin(115200);
  mySerial.begin(115200, SERIAL_8N1, RX, TX);

  pinMode(btn1ESP, INPUT_PULLUP);
  pinMode(btn2Ar, INPUT_PULLUP);
}

void loop() {
  if (mySerial.available()) {
    char state = mySerial.read();
    Serial.println(state);
    //mySerial.flush();
    //mySerial.flush();
  }

  bool espBtn = digitalRead(btn1ESP);
  if (espBtn == HIGH) {
    if (prevBtnState == false) {
      mySerial.print('0');
      Serial.println("I sent 0 to ESP");
      prevBtnState = true;
    }
  } else {
    if (prevBtnState == true) {
      mySerial.print('1');
      Serial.println("I sent 1 to ESP");
      prevBtnState = false;
      delay(100);
    }
  }

  bool arduinoBtn = digitalRead(btn2Ar);
  if (arduinoBtn == HIGH) {
    if (prevArduinoBtn == false) {
      mySerial.print('0');
      Serial.println("I sent 0 to Arduino");
      prevArduinoBtn = true;
    }
  } else {
    if (prevArduinoBtn == true) {
      mySerial.print('2');
      Serial.println("I sent 2 to Arduino");
      prevArduinoBtn = false;
      delay(100);
    }
  }
}
